#!/bin/bash

#check uninstall.sh
if [ -f /opt/apps/org.szra.kylinabcukey/uninstall.sh ];then
	sh /opt/apps/org.szra.kylinabcukey/uninstall.sh
fi

#tar -xvzf org.szra.kylinabcukey_loongarch64.tar.gz -C /opt/apps/org.szra.kylinabcukey

cd /opt/apps/org.szra.kylinabcukey
chmod -R 755 /opt/apps/org.szra.kylinabcukey

#install desktop menu
rm -fr /usr/share/applications/org.szra.kylinabcukey.desktop
mv ./xdg/org.szra.kylinabcukey.desktop /usr/share/applications/org.szra.kylinabcukey.desktop
cp -rf ./xdg/org.szra.kylinabcukey.svg /usr/share/icons/hicolor/scalable/apps

#xdg-menu
#if [ -d "/etc/xdg/menus/applications-merged/" ]; then
#	rm /etc/xdg/menus/applications-merged/org.szra.kylinabcukey.menu -fr 		
#else
#	mkdir /etc/xdg/menus/applications-merged/ -p		
#fi
#mv ./xdg/org.szra.kylinabcukey.menu /etc/xdg/menus/applications-merged/org.szra.kylinabcukey.menu
#xdg-autostart
#mv ./xdg/org.szra.kylinabcukey.desktop /etc/xdg/autostart/org.szra.kylinabcukey.desktop

#delete xdg directory
rm -rf ./xdg

#two library for abc
ln -fs /opt/apps/org.szra.kylinabcukey/Librarys/libabcSZRA93.so.1.0.0 /usr/lib/libabcsSZRA93.so
ln -fs /opt/apps/org.szra.kylinabcukey/Librarys/libabcSZRA93.so.1.0.0 /usr/lib/libabchSZRA93.so

#driver and start file
cd ./Profile
sh install.sh
cd ..
rm -rf ./Profile

#libusb
cd ./libusb
sh install.sh
cd ../
rm -rf ./libusb

#pcscd
mkdir /usr/local/rongan -p
cp -rf ./pcsc /usr/local/rongan
chmod -R 777 /usr/local/rongan/pcsc
rm -rf ./pcsc

#install xpi
cd ./xpi/SZRA
sh install.sh
cd ../../
rm -rf ./xpi

#install  daemon pcscd service
cd ./services
sh getUser.sh
cp systemd-pcscd-ra.service /lib/systemd/system
cp systemd-abcdaemon-ra.service /lib/systemd/system
systemctl daemon-reload
systemctl enable systemd-pcscd-ra.service
systemctl start systemd-pcscd-ra.service
systemctl enable systemd-abcdaemon-ra.service
systemctl start systemd-abcdaemon-ra.service
#cp * /opt/apps/org.szra.kylinabcukey/services
cd ..
rm -rf ./services

#install P11
#USER_NAME=user
#su $name -c "modutil -dbdir /home/$name/.pki/nssdb -add SZRAPKCS11 -libfile /usr/local/rongan/ABC/Librarys/libRAPKCS11.so"

#start
rm -fr /opt/apps/org.szra.kylinabcukey/uninstall.sh

cat >> /opt/apps/org.szra.kylinabcukey/uninstall.sh << EOFF
##########################uninstall->start
#!/bin/bash
#stop apps
killall abc_driver_ra 2>/dev/null 1>/dev/null
killall abcukey 2>/dev/null 1>/dev/null

#stop and disable services
systemctl stop systemd-pcscd-ra.service
systemctl disable systemd-pcscd-ra.service
systemctl stop systemd-abcdaemon-ra.service
systemctl disable systemd-abcdaemon-ra.service
rm /lib/systemd/system/systemd-pcscd-ra.service
rm /lib/systemd/system/systemd-abcdaemon-ra.service
systemctl daemon-reload

#rm xdg
rm -fr /usr/share/applications/org.szra.kylinabcukey.desktop
#rm -fr /etc/xdg/menus/applications-merged/org.szra.kylinabcukey.menu

#rm abc lib link
rm -rf /usr/lib/libabcsSZRA93.so
rm -rf /usr/lib/libabchSZRA93.so

#rm pcsc dir
#rm -fr /usr/local/rongan/

#rm app run dir
rm -rf /opt/apps/org.szra.kylinabcukey

#rm json
#USER_NAME=user
#rm -rf /home/$USER_NAME.config/browser/NativeMessagingHosts/abc_driver_ra.json

#del rc.local run
#sed -i '/usr\/local\/rongan\/pcsc\/pcscd_ra/d' /etc/rc.local

#uninstall P11
#su $name -c "modutil -dbdir /home/$name/.pki/nssdb -delete SZRAPKCS11"

echo "Unistall Success!"
EOFF
#########################uninstall->end
chmod 777 /opt/apps/org.szra.kylinabcukey/uninstall.sh

